﻿using Chaos.Components;
using System.ComponentModel;
using System.Windows;

namespace Chaos
{
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        private string text;
        public string Text
        {
            get { return text; }
            set {
                text = value;
                OnPropertyChanged("Text");
            }
        }

        public Hooker Hook { get; set; }
        private Noticon _noticon;

        public MainWindow()
        {
            InitializeComponent();

            this.Hook = new Hooker((x) => { this.Text += x; });
            (this._noticon = new Noticon(this)).Visible = true;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }

        private void Window_Closing(object sender, CancelEventArgs e)
        {
            this.Visibility = Visibility.Hidden;
            e.Cancel = true;
        }

        private void Window_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.Key == System.Windows.Input.Key.Escape)
                this.Close();
        }
    }
}
